#include <sys/socket.h>
#include <sys/types.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

int main() {
    struct addrinfo hints;
    struct addrinfo * result;

    memset(&hints, 0, sizeof(struct addrinfo));
    hints.ai_family = AF_INET;
    hints.ai_socktype = SOCK_DGRAM;
    hints.ai_protocol = 0;
    hints.ai_flags = AI_PASSIVE;
    hints.ai_addr = NULL;
    hints.ai_next = NULL;

    int err = getaddrinfo("127.0.0.1", "23333", &hints, &result);
    if (err != 0) {
        fprintf(stderr, "getaddrinfo failed: %s\n", gai_strerror(err));
        exit(EXIT_FAILURE);
    }

    int sock_fd;
    struct addrinfo * i;
    for (i = result; i != NULL; i = i->ai_next) {
        sock_fd = socket(i->ai_family, i->ai_socktype, i->ai_protocol);
        if (sock_fd == -1)
            continue;

        if (connect(sock_fd, i->ai_addr, i->ai_addrlen) != -1)
            break;

        close(sock_fd);
    }

    freeaddrinfo(result);

    if (i == NULL) {
        fprintf(stderr, "Could not connect\n");
        exit(EXIT_FAILURE);
    }

    char x = 1;
    send(sock_fd, &x, 1, 0); x++;
    send(sock_fd, &x, 1, 0); x++;
    send(sock_fd, &x, 1, 0); x++;

    close(sock_fd);

    return EXIT_SUCCESS;
}
