#include <sys/socket.h>
#include <sys/types.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "myutil.h"

int main() {
    struct addrinfo hints;
    memset(&hints, 0, sizeof(struct addrinfo));
    hints.ai_family = AF_INET;
    hints.ai_socktype = SOCK_DGRAM;
    hints.ai_protocol = 0;
    hints.ai_flags = AI_PASSIVE;
    hints.ai_addr = NULL;
    hints.ai_next = NULL;

    struct addrinfo *result;
    int err = getaddrinfo(NULL, "23333", &hints, &result);
    if (err != 0) {
        fprintf(stderr, "getaddrinfo failed: %s\n", gai_strerror(err));
        exit(EXIT_FAILURE);
    }

    int sock_fd;
    struct addrinfo * i;
    for (i = result; i != NULL; i = i->ai_next) {
        sock_fd = socket(i->ai_family, i->ai_socktype, i->ai_protocol);
        if (sock_fd == -1)
            continue;

        if (bind(sock_fd, i->ai_addr, i->ai_addrlen) == 0)
            break;
    }

    freeaddrinfo(result);

    if (i == NULL) {
        fprintf(stderr, "Could not bind\n");
        exit(EXIT_FAILURE);
    }

    size_t BUF_SIZE = 1024;
    char buffer[BUF_SIZE];
    struct sockaddr_storage peer_addr;
    socklen_t peer_addr_len = sizeof(struct sockaddr_storage);

    for (int i = 0; i < 3; i++) {
        if (i == 1)
            sleep(1);
        ssize_t nread = recvfrom(
            sock_fd, buffer, BUF_SIZE, 0, (struct sockaddr *)&peer_addr, &peer_addr_len
        );

        fprintf(stdout, "read %ld bytes: ", nread);
        print_buffer(stdout, buffer, nread);
        fprintf(stdout, "\n");
    }

    return EXIT_SUCCESS;
}
